package IntegrationObject;

// Host On-Demand support
import com.ibm.eNetwork.beans.HOD.*;            // HOD JavaBeans
import com.ibm.eNetwork.beans.HOD.event.*;      // HOD JavaBeans events
import com.ibm.eNetwork.beans.HOD.trace.*;      // HOD JavaBeans trace
import com.ibm.eNetwork.ECL.*;                  // Host Access Class Library

//Host Publisher run time support
import com.ibm.HostPublisher.Server.*;
import com.ibm.HostPublisher.IntegrationObject.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.lang.*;
import java.lang.reflect.*;
import java.beans.*;
import java.util.zip.*;


public class Callupchain2 extends HPubCommon implements 
                                          MacroRuntimeListener,
                                          MacroParseListener,
                                          TraceListener,
                                          Serializable,
                                          Runnable
{
  // Bean State Constants
  public static final int MACRO_STATE_NOT_INSTANTIATED = 0;
  public static final int MACRO_STATE_INSTANTIATED     = 1;
  public static final int MACRO_STATE_READY_TO_PLAY    = 2;
  public static final int MACRO_STATE_PLAYING          = 3;
  public static final int MACRO_STATE_PARSE_ERROR      = 4;
  public static final int MACRO_STATE_PLAY_FINISHED    = 5;

  int intMacroState = MACRO_STATE_NOT_INSTANTIATED;

  // File Separtor for, used to locate macro file
  static String staticstringFileSeparator = new String(System.getProperty("file.separator"));

  boolean booleanFirstTimeHere = true;

  // Vector of Generated Objects
  Vector        vHAOVariables = new Vector();

  // HostPublisher Session Manager objects
  HodConn    oConn = null;

  // HOD objects
  Macro         macroBean = null;
  Session       sessionHost = null;
  String        stringMacroName = null;
  ECLSession    eclsessionHost = null;

  // Variable to determine processing of HOD extract events
  int           intCodePage = 0;
  String        stringCodePage = null;
  boolean       booleanDBCSCodePageInUse = false;

  // Variables used to make known the bean's status
  public String hPubScreenState = null;
  public String hPubMacroMessage = null;

  // HOD Error Message holder
  public String stringHODMacroError = null;

  // Generated Objects
  HAOVariable extractResults = new HAOVariable("","extractResults","extractResults",false,"",0,0,71,6,HAO_VARIABLE_SIMPLE);

  HAOVariable extractResultsname = new HAOVariable("","extractResults","extractResultsname",false,"",0,0,37,6,HAO_VARIABLE_ARRAY);
  HAOVariable extractResultsempSt = new HAOVariable("","extractResults","extractResultsempSt",false,"",37,0,6,6,HAO_VARIABLE_ARRAY);
  HAOVariable extractResultstie_line = new HAOVariable("","extractResults","extractResultstie_line",false,"",43,0,9,6,HAO_VARIABLE_ARRAY);
  HAOVariable extractResultsnode = new HAOVariable("","extractResults","extractResultsnode",false,"",52,0,9,6,HAO_VARIABLE_ARRAY);
  HAOVariable extractResultsuser_ID = new HAOVariable("","extractResults","extractResultsuser_ID",false,"",61,0,10,6,HAO_VARIABLE_ARRAY);

  public static final String stringHODMacroFilename = "Callupchain2.macro";
  public String stringBeanName = new String("Callupchain2");


  // Contructor
  public Callupchain2()
  { // Generated vector population
    vHAOVariables.addElement(extractResults);


    vHAOVariables.addElement(extractResultsname);
    vHAOVariables.addElement(extractResultsempSt);
    vHAOVariables.addElement(extractResultstie_line);
    vHAOVariables.addElement(extractResultsnode);
    vHAOVariables.addElement(extractResultsuser_ID);


   hPubBeanType = new String("HOD");


    hPubStartPoolName  = null;
    hPubStartChainName = new String("Initial Search Results");
    hPubStartType         = BEAN_START_FROM_CONNECTION;


    hPubEndChainName   = new String("Initial Search Results");
    hPubEndType           = BEAN_END_TO_CONNECTION;


  }


  // *************************************************************************
  /* Generated Setters */


  /* Generated Getters */
  public String getExtractResults()
  {
     hPubErrorOccurred = 0;
     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getExtractResults simple: ", extractResults.stringValue); }
     return (extractResults.stringValue);
  }

  public synchronized String getExtractResultsname(int i)
  {
     hPubErrorOccurred = 0;
     if (  (extractResultsname.oMultiValues.size() != 0)
         &&(i >= 0)
         &&(i < extractResultsname.oMultiValues.size())
        )
     { 
       if (HPubTracingOn)
       { Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultsname array: ",
           integerX.toString(), (String) extractResultsname.oMultiValues.elementAt(i));
       }

       return ( (String) extractResultsname.oMultiValues.elementAt(i));
     }
     else
     { if (HPubTracingOn)
       {
         Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultsname array element ", "Throwing out of bounds on iteration: ",
           integerX.toString());
       }

       throw new ArrayIndexOutOfBoundsException("Row is Out of Bounds");
     }
  }

  public String[] getExtractResultsname()
  {
     hPubErrorOccurred = 0;

     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getExtractResultsname ", "array all"); }

     extractResultsname.oStringArray = new String[extractResultsname.oMultiValues.size()];
     extractResultsname.oMultiValues.copyInto(extractResultsname.oStringArray);
     return (String[])extractResultsname.oStringArray.clone();
  }
  public synchronized String getExtractResultsempSt(int i)
  {
     hPubErrorOccurred = 0;
     if (  (extractResultsempSt.oMultiValues.size() != 0)
         &&(i >= 0)
         &&(i < extractResultsempSt.oMultiValues.size())
        )
     { 
       if (HPubTracingOn)
       { Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultsempSt array: ",
           integerX.toString(), (String) extractResultsempSt.oMultiValues.elementAt(i));
       }

       return ( (String) extractResultsempSt.oMultiValues.elementAt(i));
     }
     else
     { if (HPubTracingOn)
       {
         Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultsempSt array element ", "Throwing out of bounds on iteration: ",
           integerX.toString());
       }

       throw new ArrayIndexOutOfBoundsException("Row is Out of Bounds");
     }
  }

  public String[] getExtractResultsempSt()
  {
     hPubErrorOccurred = 0;

     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getExtractResultsempSt ", "array all"); }

     extractResultsempSt.oStringArray = new String[extractResultsempSt.oMultiValues.size()];
     extractResultsempSt.oMultiValues.copyInto(extractResultsempSt.oStringArray);
     return (String[])extractResultsempSt.oStringArray.clone();
  }
  public synchronized String getExtractResultstie_line(int i)
  {
     hPubErrorOccurred = 0;
     if (  (extractResultstie_line.oMultiValues.size() != 0)
         &&(i >= 0)
         &&(i < extractResultstie_line.oMultiValues.size())
        )
     { 
       if (HPubTracingOn)
       { Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultstie_line array: ",
           integerX.toString(), (String) extractResultstie_line.oMultiValues.elementAt(i));
       }

       return ( (String) extractResultstie_line.oMultiValues.elementAt(i));
     }
     else
     { if (HPubTracingOn)
       {
         Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultstie_line array element ", "Throwing out of bounds on iteration: ",
           integerX.toString());
       }

       throw new ArrayIndexOutOfBoundsException("Row is Out of Bounds");
     }
  }

  public String[] getExtractResultstie_line()
  {
     hPubErrorOccurred = 0;

     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getExtractResultstie_line ", "array all"); }

     extractResultstie_line.oStringArray = new String[extractResultstie_line.oMultiValues.size()];
     extractResultstie_line.oMultiValues.copyInto(extractResultstie_line.oStringArray);
     return (String[])extractResultstie_line.oStringArray.clone();
  }
  public synchronized String getExtractResultsnode(int i)
  {
     hPubErrorOccurred = 0;
     if (  (extractResultsnode.oMultiValues.size() != 0)
         &&(i >= 0)
         &&(i < extractResultsnode.oMultiValues.size())
        )
     { 
       if (HPubTracingOn)
       { Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultsnode array: ",
           integerX.toString(), (String) extractResultsnode.oMultiValues.elementAt(i));
       }

       return ( (String) extractResultsnode.oMultiValues.elementAt(i));
     }
     else
     { if (HPubTracingOn)
       {
         Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultsnode array element ", "Throwing out of bounds on iteration: ",
           integerX.toString());
       }

       throw new ArrayIndexOutOfBoundsException("Row is Out of Bounds");
     }
  }

  public String[] getExtractResultsnode()
  {
     hPubErrorOccurred = 0;

     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getExtractResultsnode ", "array all"); }

     extractResultsnode.oStringArray = new String[extractResultsnode.oMultiValues.size()];
     extractResultsnode.oMultiValues.copyInto(extractResultsnode.oStringArray);
     return (String[])extractResultsnode.oStringArray.clone();
  }
  public synchronized String getExtractResultsuser_ID(int i)
  {
     hPubErrorOccurred = 0;
     if (  (extractResultsuser_ID.oMultiValues.size() != 0)
         &&(i >= 0)
         &&(i < extractResultsuser_ID.oMultiValues.size())
        )
     { 
       if (HPubTracingOn)
       { Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultsuser_ID array: ",
           integerX.toString(), (String) extractResultsuser_ID.oMultiValues.elementAt(i));
       }

       return ( (String) extractResultsuser_ID.oMultiValues.elementAt(i));
     }
     else
     { if (HPubTracingOn)
       {
         Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getExtractResultsuser_ID array element ", "Throwing out of bounds on iteration: ",
           integerX.toString());
       }

       throw new ArrayIndexOutOfBoundsException("Row is Out of Bounds");
     }
  }

  public String[] getExtractResultsuser_ID()
  {
     hPubErrorOccurred = 0;

     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getExtractResultsuser_ID ", "array all"); }

     extractResultsuser_ID.oStringArray = new String[extractResultsuser_ID.oMultiValues.size()];
     extractResultsuser_ID.oMultiValues.copyInto(extractResultsuser_ID.oStringArray);
     return (String[])extractResultsuser_ID.oStringArray.clone();
  }

  public String getHPubScreenState()
  { // Name of the HOD Macro screen when a macroStateEvent was received
    // and the macro state was STATE_STOPPED, STATE_PLAYING, or STATE_PLAY_ERROR
    hPubErrorOccurred = 0;
    if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getHPubScreenState: ", hPubScreenState); }
    return hPubScreenState;
  }

  public String getHPubMacroMessage()
  {  // The getMessage string receive from the HOD Macro on the
     // latest macroMessageEvent.  
     hPubErrorOccurred = 0;
     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getHPubMacroMessage: ", hPubMacroMessage); }
     return hPubMacroMessage;
  }

  // *************************************************************************

  public void DoTheWork()
  { // This is the main method for the bean.  In this method the bean will
    // acquire a session to the host and invoke the HOD macro.  Events
    // fired by the HOD subsystem will be used to communicate with the
    // macro and host.

    StringBuffer stringbufferMacro = new StringBuffer();
    String stringNextLine = null;

    StringBuffer    stringbufferPathToMacro = null;
    FileInputStream fileinputstreamMacro = null;

    if (HPubTracingOn)
    { Ras.traceEntry( this.getClass().getName(),"DoTheWork");
    }

    hPubErrorException = null;
    hPubErrorOccurred = 0;

    if (booleanFirstTimeHere == true)
    { booleanFirstTimeHere = false;
    }
    else
    { // reset output variables if bean is being called multiple times.
      resetCurrentVariableValues();
    }

    try
    { // Call extended class to get a HostPublisher session.  It will handle exceptions and
      // return null if there is a problem
      oConn = (HodConn) acquireSessionFromSessionManager(stringBeanName);

      if (oConn == null)
      { // Trace and Log Error
        HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
        oErrorsToLog.handleMessage(oHttpServletRequest, stringBeanName, this.getClass().getName(),
          "DoTheWork", "HodConn_Error_1", HPubTracingOn);

        if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"DoTheWork"); }
        return;
      }

      // Get the HOD session 
      sessionHost = oConn.getConnection();
      if (sessionHost == null)
      { // Log and Trace the Error   
        HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
        oErrorsToLog.handleMessage(oHttpServletRequest, stringBeanName, this.getClass().getName(),
          "DoTheWork", "BeanConn_Error_3", HPubTracingOn);

        // return session back to source
        releaseSessionToSessionManager(BEAN_END_TO_POOL);

        // invoke error page
        hPubErrorOccurred = 1;
        responseWithErrorKey("BeanConn_Error_3");

        if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"DoTheWork"); }
        return;
      }

      // Get the HOD ECL session to determine if the codepage being used is DBCS
      eclsessionHost = sessionHost.getECLSession();       
      intCodePage = eclsessionHost.GetCodePage();

      if (intCodePage == 37)
      { // Need 37 to convert to "037"
        stringCodePage = "037";
      }
      else
      { Integer integerTemp = new Integer(intCodePage);
        stringCodePage = integerTemp.toString();
      }
      if (isDBCSCodePage(stringCodePage)) 
      { booleanDBCSCodePageInUse = true;                                
      }
      else
      { booleanDBCSCodePageInUse = false;                                
      }

      // Locate the file name of the HOD macro that is being used with this bean.
      // Could not make this part of the bean's jar file due to unicode considerations.
      stringbufferPathToMacro = new StringBuffer (com.ibm.HostPublisher.Server.Runtime.getBeansDir());
      stringbufferPathToMacro.append(staticstringFileSeparator);
      stringbufferPathToMacro.append(stringHODMacroFilename);

      try
      {
        fileinputstreamMacro = new FileInputStream(stringbufferPathToMacro.toString());
      }
      catch(Exception oException)
      {
        ResourceBundle res = ResourceBundle.getBundle("com.ibm.HostPublisher.IntegrationObject.HPub_Resources",
                                                       Locale.getDefault());

        // Log and Trace the Error
        HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
        String stringTemp1 = new String(res.getString("Macro_File_Name"));
        oErrorsToLog.concatAndAddStrings(stringTemp1, stringbufferPathToMacro.toString());
        oErrorsToLog.handleException(oException, oHttpServletRequest, stringBeanName,
                           this.getClass().getName(), "DoTheWork", "Internal_Error_1", HPubTracingOn);

        releaseSessionToSessionManager(BEAN_END_TO_POOL);

        // invoke error page
        hPubErrorOccurred = 1;
        responseWithErrorKey("Internal_Error_1");
        if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"DoTheWork"); }
        return;
      }

      if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"DoTheWork","Instantiate a HOD Macro object"); }
      macroBean = new Macro();
      intMacroState = MACRO_STATE_INSTANTIATED;
      stringMacroName = new String(stringHODMacroFilename);

      synchronized(this)
      { try
        { // listen for HOD Macro events for this macro
          macroBean.addMacroRuntimeListener(this);
          macroBean.addMacroParseListener(this);

          // Query the Host Publisher trace settings for HOD
          HODRasSettings oHODRasSettings = HODRas.getHODRasSettings();
          try
          {  
            if (oHODRasSettings != null)
            { macroBean.setTraceLevel(oHODRasSettings.getMacroTracingLevel());
              macroBean.addTraceListener(this);
            }
          }
          catch (PropertyVetoException pvEx)
          {
            // ignore
          }

          // Set the string representation of the macro in the HOD macro object
          BufferedReader bufferedreaderMacro  = new BufferedReader(new InputStreamReader (fileinputstreamMacro) );
          while ( (stringNextLine = bufferedreaderMacro.readLine()) != null)
          { stringbufferMacro.append(stringNextLine);
          }
          macroBean.setMacro(stringbufferMacro.toString());

          sessionHost.addCommListener(macroBean);

          if (intMacroState == MACRO_STATE_INSTANTIATED)
          { if (HPubTracingOn)
            { Ras.trace( this.getClass().getName(),"DoTheWork","Waiting for macro state event STATE_STOPPED to fire");
            }
            // wait for a macroStateEvent with STATE_STOPPED before continuing.
            wait();
          }
          else
          { if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"DoTheWork","Ready to play macro"); }
          }
        }
        catch(InterruptedException oException)
        { // Log and Trace the Error
          HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
          oErrorsToLog.handleException(oException, oHttpServletRequest, stringBeanName,
                             this.getClass().getName(), "DoTheWork", "Interrupted_Error_1", HPubTracingOn);

          releaseSessionToSessionManager(BEAN_END_TO_POOL);

          // invoke error page
          hPubErrorOccurred = 1;
          responseWithErrorKey("Interrupted_Error_1");
          if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"DoTheWork"); }
          return;
        }
      }

      if (intMacroState == MACRO_STATE_READY_TO_PLAY)
      { // To avoid a possible deadlock with HOD when a macro error occurs, the play() will
        // be moved outside of the synchronized block and the state variable will be used
        // to avoid errant processing on our part.
        if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"DoTheWork","Call Macro.play()"); }
        intMacroState = MACRO_STATE_PLAYING;

        // Play the macro - what we're here for!
        macroBean.play();

        synchronized(this)
        { if (intMacroState != MACRO_STATE_PLAY_FINISHED)
          try
          { wait();
          }
          catch(InterruptedException oException)
          { // Trace and Log Error
            HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
            oErrorsToLog.handleException(oException, oHttpServletRequest, stringBeanName,
                               this.getClass().getName(), "DoTheWork", "Interrupted_Error_1", HPubTracingOn);

            releaseSessionToSessionManager(BEAN_END_TO_POOL);

            // invoke error page
            hPubErrorOccurred = 1;
            responseWithErrorKey("Interrupted_Error_1");
            if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"DoTheWork"); }
            return;
          }
        }
      }
    }

    // catch MacroException here
    catch (MacroException oException)
    { // Trace and Log Error
      HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
      oErrorsToLog.handleException(oException, oHttpServletRequest, stringBeanName,
                         this.getClass().getName(), "DoTheWork", "HOD_Macro_Error_1", HPubTracingOn);

      releaseSessionToSessionManager(BEAN_END_TO_POOL);

      // invoke error page
      hPubErrorOccurred = 1;
      responseWithErrorKey("HOD_Macro_Error_1");

      if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"DoTheWork"); }
      return;

    }

    catch (Exception oException)
    { // Trace and Log Error
      HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
      oErrorsToLog.handleException(oException, oHttpServletRequest, stringBeanName,
                         this.getClass().getName(), "DoTheWork", "Internal_Error_1", HPubTracingOn);

      releaseSessionToSessionManager(BEAN_END_TO_POOL);

      // invoke error page
      hPubErrorOccurred = 1;
      responseWithErrorKey("Internal_Error_1");

      if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"DoTheWork"); }
      return;
    }

    releaseSessionToSessionManager(hPubEndType);

    if (stringHODMacroError != null)
    { hPubErrorOccurred = 1;
      responseWithErrorKey(stringHODMacroError);
    }

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"DoTheWork"); }
  }

  // *************************************************************************

  public void resetCurrentVariableValues()
  { // This bean can be called (using the DoTheWork method) multiple times
    // without having to be instantiated each time.  Therefore the output
    // values need to be reset upon each call.

    HAOVariable haovWorkOnThis;

    if (HPubTracingOn)
    { Ras.traceEntry( this.getClass().getName(),"resetCurrentVariableValues");
    }

    hPubErrorOccurred = 0;
    hPubScreenState = null;

    for (int i=0; i < vHAOVariables.size(); i++)
    { haovWorkOnThis = (HAOVariable) vHAOVariables.elementAt(i);
      if (haovWorkOnThis.intVariableType == HAO_VARIABLE_SIMPLE)
      { // simple variable
        if (haovWorkOnThis.booleanInputVariable == false)
        { // if variable is output, reset null
          // if variable is input,  leave value as is.
          haovWorkOnThis.stringValue = null;
        }
      }
      else
      { // vector variable
        // Garbage collect
        haovWorkOnThis.oMultiValues = null;
        // Set up new vector
        haovWorkOnThis.oMultiValues = new Vector();
      }
    }

    if (HPubTracingOn)
    { Ras.traceExit( this.getClass().getName(),"resetCurrentVariableValues");
    }
  }

  // *************************************************************************

  public void releaseSessionToSessionManager(int intEndType)
  { 
    //  Releaase the session back to the HostPublisher Subsystem and
    //  perform general clean up.
    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"releaseSessionToSessionManager"); }

    try
    { if (sessionHost != null)
      { if (HPubTracingOn)
        { Ras.trace( this.getClass().getName(),"releaseSessionToSessionManager","Release HOD Session object");
        } 
        // remove the HOD session listeners
        sessionHost.removeCommListener(macroBean);
        sessionHost = null;
      }
      if (macroBean != null)
      { if (HPubTracingOn)
        { Ras.trace( this.getClass().getName(),"releaseSessionToSessionManager","Release HOD Macro object");
        } 
        // remove the HOD Macro listeners
        macroBean.removeMacroParseListener(this);
        macroBean.removeMacroRuntimeListener(this);
        macroBean.dispose(); 
        macroBean = null;
      }
    }
    catch (MacroException oException)
    { // ignore, because we are attempting to clean up.
    }

    if (oConn != null)
    { if (HPubTracingOn)
      { Ras.trace( this.getClass().getName(),"releaseSessionToSessionManager","Release HPub connection object");
      } 
      try
      { switch (intEndType)
        { case BEAN_END_TO_POOL:
            // Release the session back to HostPublisher
            oConn.releaseConnectionToSource(oHttpServletRequest, this);
          break;
      
          case BEAN_END_TO_CONNECTION:
            // This was a chained bean, so release the session back to HostPublisher
            // using a different method.
            oConn.saveConnectionInWebsession(oHttpServletRequest, hPubEndChainName, this);
          break;
        }
        oConn = null;

        cleanupHPubCommon();

      }
      catch (ConnException oException)
      { // Trace and Log Error
        HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
        oErrorsToLog.handleException(oException, oHttpServletRequest, stringBeanName,
                           this.getClass().getName(), "releaseSessionToSessionManager", HPubTracingOn);
  
      }
    }

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"releaseSessionToSessionManager"); }
    return;
  }

  // *************************************************************************

  protected void finalize()
  {
    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"finalize"); } 
    releaseSessionToSessionManager(BEAN_END_TO_POOL);
    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"finalize"); }
  }

  // *************************************************************************

  public void parseFailed(MacroParseEvent eventParseError)
  { // HOD parse event fired for this macro
  
    // Not the our macros would fail to parse, but if the user hand-modified
    // a macro, we need to catch the error here

    // Log and trace the error
    MacroParseStat mpStat;
    HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"parseFailed"); }
    ResourceBundle res = ResourceBundle.getBundle("com.ibm.HostPublisher.IntegrationObject.HPub_Resources",
                                                  Locale.getDefault());

    intMacroState = MACRO_STATE_PARSE_ERROR;

    if (macroBean != null)
    { String stringTemp1 = new String(res.getString("Macro_Name"));
      oErrorsToLog.concatAndAddStrings(stringTemp1, stringMacroName);
    }

    oErrorsToLog.handleMessage(oHttpServletRequest, stringBeanName, this.getClass().getName(),
      "parseFailed", "HOD_Macro_Parse_Error_1", HPubTracingOn);

    for (Enumeration e = eventParseError.parseStats(); e.hasMoreElements();)
    {
      mpStat = (MacroParseStat) e.nextElement();
      StringBuffer stringbufferErrorMessage = new StringBuffer(new Integer(mpStat.getLineNum()).toString());
      stringbufferErrorMessage.append(mpStat.getLineText());
      stringbufferErrorMessage.append(mpStat.getStatMessage());
      if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"parseFailed",stringbufferErrorMessage.toString()); }

    }

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"parseFailed"); }
  }

  // *************************************************************************

  public void parsePassed()
  { // What we expected, so only trace that we go here
    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"parsePassed"); }
    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"parsePassed"); }
  }

  // *************************************************************************

  public synchronized void macroMessageEvent(MacroMessageEvent mmEv)
  { // A HOD Macro message event was fired for this macro.
  
    // If there was a message associated with a macro screen (the only way
    // to do this in this release is for the user to hand edit the macro file)
    // then store it here, in this way another program can query about what
    // screen the bean ended at.
    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"macroMessageEvent"); }
    hPubMacroMessage = mmEv.getMessage();
    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"macroMessageEvent"); }

  }

  // *************************************************************************

  public void traceEvent(TraceEvent tEv)
  { // A HOD trace event was fired 

    // If tracing is on, or the trace event was a HOD exception, then
    // pass this on to the HostPublisher subsystem for tracing. 

    int intMessageType;

    intMessageType = tEv.getMsgType();

    if (  (HPubTracingOn)
        ||(intMessageType == TraceEvent.LOGEXCEPTION)
       )
    {
      if (oConn != null)
      {
        oConn.traceEvent(tEv);
      }
    }
  }

  // *************************************************************************

  public synchronized void macroTraceEvent(MacroTraceEvent mtEv)
  { // A HOD trace event was fired for this macro  

    // If tracing is on, then pass this on to the HostPublisher subsystem
    // for tracing.
    if (HPubTracingOn)
    { 
      Ras.trace(this.getClass().getName(), "macroTraceEvent", mtEv.getData());
    }
  }

  // ****************************************************************************

  public void macroErrorEvent(MacroErrorEvent oMacroErrorEvent)
  { // A HOD error event was fired for this macro

    HPubErrorsToLog      oErrorsToLog = new HPubErrorsToLog();

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"macroErrorEvent"); }

    // Most of the error reporting will be done when the subsequent
    //  MacroStateEvent.STATE_PLAY_ERROR is received.  But log the
    //  Error Event Message now.
    if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroErrorEvent: ", oMacroErrorEvent.getMessage()); }
    
    oErrorsToLog.stringToLog(oMacroErrorEvent.getMessage());
    oErrorsToLog.log(Ras.TYPE_ERROR, stringBeanName, this.getClass().getName() );

    stringHODMacroError = new String("HOD_Macro_Error_1");

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"macroErrorEvent"); }
  }

  // ****************************************************************************

  public void macroPromptEvent(MacroPromptEvent oMacroPromptEvent)
  { // A HOD Macro prompt event was fired for this macro

    MacroPrompts oMacroPrompts;
    HAOVariable haovWorkOnThis;

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"macroPromptEvent"); }

    // Get the HOD macro prompt object
    oMacroPrompts = oMacroPromptEvent.getPrompts();
    synchronized (this)
    { for (int i=0; i < vHAOVariables.size(); i++)
      { haovWorkOnThis = (HAOVariable) vHAOVariables.elementAt(i);

        // Populate the object with the prompt values that were given to the bean
        // via the "set" methods.
        if (haovWorkOnThis.booleanInputVariable == true)
        { if (  (  (haovWorkOnThis.stringValue != null)
                 &&(haovWorkOnThis.stringValue.length() > 0)
                )
              ||(  (oMacroPrompts.getPromptDefault(haovWorkOnThis.stringPromptName) != null)
                 &&(oMacroPrompts.getPromptDefault(haovWorkOnThis.stringPromptName).length() > 0) 
                )
             )
          { // If the object has a prompt value (usually obtain via the beans "set" methods),
            // Or, if the object has not be given a prompt value but there has been
            // defined a default value, 
            // then set it in the HOD Prompt object with
            // the prompt name that was given by the user (using the Host Access GUI).
            if (HPubTracingOn)
            { Ras.trace( this.getClass().getName(),"macroPromptEvent","Setting the following Prompt Name and Value",
                         haovWorkOnThis.stringPromptName, haovWorkOnThis.stringValue);

            }
            oMacroPrompts.setPromptValue(haovWorkOnThis.stringPromptName,haovWorkOnThis.stringValue);

          }
          else
          { // If the prompt value can not be set, and there is no default,
            // then find the HOD prompt name for this object and set the prompt action to skip.

            MacroActionPrompt oMacroActionPrompt = null;
            String stringThisPromptName = new String(haovWorkOnThis.stringPromptName);
            int intNumberOfPrompts = oMacroPrompts.size();
            
            for (int j=0; j < intNumberOfPrompts; j++)  
            { 
              oMacroActionPrompt = oMacroPrompts.get(j);
              if (stringThisPromptName.equals(oMacroActionPrompt.getName()))
              { oMacroActionPrompt.setSkip(true);
                if (HPubTracingOn)
                { Ras.trace( this.getClass().getName(),"macroPromptEvent",
                             "MacroActionPrompt.setSkip called on the following Prompt Name",
                             haovWorkOnThis.stringPromptName);
                }
                break;
              }
              oMacroActionPrompt = null;  // quick garbage collect
            }
          }
        }
      }
    }
    try
    { oMacroPromptEvent.setPrompts(oMacroPrompts);
    }
    catch (MacroException oException)
    { // Trace and Log Error
      HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
      oErrorsToLog.handleException(oException, oHttpServletRequest, stringBeanName,
                         this.getClass().getName(), "macroPromptEvent", "HOD_Macro_Error_1", HPubTracingOn);
    }

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"macroPromptEvent"); }
  }

  // ****************************************************************************

  public void macroExtractEvent(MacroExtractEvent oMacroExtractEvent)
  { // a HOD macroExtractEvent was fired for this macro

    HAOVariable haovWorkOnThis;

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"macroExtractEvent"); }

    // extract the data (VT,3270, 5250 datastream/emulator) that was associated with this extract
    String stringExtractNameForThisEvent = oMacroExtractEvent.getExtractName();
    String data [] = oMacroExtractEvent.getData();  

    if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroExtractEvent","Extract Name: ", stringExtractNameForThisEvent); }

    // Go through list of objects, for each variable
    // whose extract name matches stringExtractName, extract
    // the correct fields for that object
    synchronized (this)
    { for (int i = 0; i < vHAOVariables.size(); i++)
      { haovWorkOnThis = (HAOVariable) vHAOVariables.elementAt(i);
        if ( haovWorkOnThis.stringExtractName.equals(stringExtractNameForThisEvent) == true)
        { pullVariableValueFromExtractData( haovWorkOnThis, data);
        }
      }
    }

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"macroExtractEvent"); }

    return;
  }

  // ****************************************************************************

  public void pullVariableValueFromExtractData( HAOVariable haovTarget, String [] stringarrayExtractData)
  {
    // To make life easy
    // X is horizontal, Y is Vertical
    int intX  = haovTarget.intXLocation;
    int intDX = haovTarget.intXDelta;
    int intY  = haovTarget.intYLocation;
    int intDY = haovTarget.intYDelta;

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"pullVariableValueFromExtractData"); }

    // Check parameters, if invalid log error and return
    if (  (intDX == 0)
        ||(intDY == 0)
        ||(intX < 0 )
        ||(intY < 0 )
        ||(intY >= stringarrayExtractData.length)
        ||(intY + intDY > stringarrayExtractData.length)
       )
    { // log and trace error
      HPubErrorsToLog oErrorsToLog = new HPubErrorsToLog();
      oErrorsToLog.handleMessage(oHttpServletRequest, stringBeanName, this.getClass().getName(),
        "pullVariableValueFromExtractData", "HOD_Macro_Error_2", HPubTracingOn);

      if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"pullVariableValueFromExtractData"); }
      return;
    }

    if (haovTarget.intVariableType == HAO_VARIABLE_SIMPLE)
    { // simple (non-table) extract/object
      StringBuffer stringbufferHoldingValue;

      // concatenate multiple extracts which have the same name
      if (haovTarget.stringValue == null)
      { stringbufferHoldingValue = new StringBuffer("");
      }
      else
      { stringbufferHoldingValue = new StringBuffer(haovTarget.stringValue);
      }

      if (intDY == 1)
      { // This extract is contained in one row of data
        String stringOutput = pullStringFromIndexes(stringarrayExtractData[intY], intX, intDX,
                                                    haovTarget.intVariableType );
        stringbufferHoldingValue.append(stringOutput);
      }
      else
      { for (int j = 0; j < intDY; j++)
        { // This extract spans multiple rows of data.
          String stringOutput = pullStringFromIndexes(stringarrayExtractData[intY+j], intX, intDX,
                                                      haovTarget.intVariableType );
          stringbufferHoldingValue.append(stringOutput); 
        }
      }

      if (stringbufferHoldingValue.toString() != null)
      { // store value in object
        haovTarget.stringValue = new String( stringbufferHoldingValue.toString() );
      }

      if (HPubTracingOn)
      { Ras.trace( this.getClass().getName(),"pullVariableValueFromExtractData",
        "Simple Variable Value Extracted: ", haovTarget.stringValue);
      }
    }
    else
    { // vector (table) extract/object
      for (int j = 0; j < intDY; j++)
      { // Go through each row and get this columns worth of data
        String stringOutput = pullStringFromIndexes(stringarrayExtractData[intY+j], intX, intDX,
                                                    haovTarget.intVariableType );

        if (HPubTracingOn)
        { Integer integerX = new Integer(j);
          Ras.trace( this.getClass().getName(),"pullVariableValueFromExtractData ", integerX.toString(),
           stringOutput);  
        }
        // One object holds the entire column of data
        haovTarget.oMultiValues.addElement(new String(stringOutput));
      }
    }

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"pullVariableValueFromExtractData"); }
  }

  // ****************************************************************************

  public String pullStringFromIndexes( String stringInput, int intX, int intDX, int intVariableType)
  { // stringInput - string from which to acquire the substring.
    // intX - starting index of the substring 
    // intDX - length of the substring
    // intVariableType - if substring is a Simple object (non-table) or Vector (table)
    // output - resulting substring
    // This routine would not be needed, except for the case of the simple object
    // that has DBCS characters, as described below

    int intCount;
    int intExtractStart;
    int intExtractLength;
    int intInputLength;

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"pullStringFromIndexes"); }

    if (booleanDBCSCodePageInUse)
    {
      // Screen Coordinates, and not Extract Coordinates are given for DBCS and Simple Variables
      if (HPubTracingOn)
      { Ras.trace(this.getClass().getName(),"pullStringFromIndexes", "DBCS Code Page In Use detected");                                    
      }
      intInputLength = stringInput.length();
      // find where X starts inside of stringInput
      intCount = 0;
      for (intExtractStart=0; intExtractStart < intInputLength; intExtractStart++)
      { if (intCount >= intX) break;
        
        if ( IsDBCSChar(stringInput.charAt(intExtractStart)) )
        { // DBCS characters take up two columns, but only one extracted character element
          Ras.trace(this.getClass().getName(),"pullStringFromIndexes", "Extract Start - DBCS Character found");                                     
          intCount+=2;  
        }
        else
        { intCount ++;
        }
      }
     
      // Find the length of the desired extract
      intCount = 0;
      for (intExtractLength = 0; intExtractLength < intInputLength - intExtractStart; intExtractLength++)
      { if (intCount >= intDX) break;
     
        if ( IsDBCSChar(stringInput.charAt(intExtractStart+intExtractLength)) )
        { // DBCS characters take up two columns, but only one extracted character element 
          Ras.trace(this.getClass().getName(),"pullStringFromIndexes", "Extract Length - DBCS Character found");                               
          intCount+=2;  
        }
        else
        { intCount ++;
        }
      }
    }
    else
    { // For single byte and table variables, the coordinates given in the extract match
      // the coordinates that were determined by the Host Access GUI.
      intExtractStart = intX;
      intExtractLength = intDX;
    }

    if (HPubTracingOn)
    { Integer integerTemp = new Integer(intExtractStart);
      Ras.trace(this.getClass().getName(),"pullStringFromIndexes", "extract start index: ", integerTemp);                      
      integerTemp = new Integer(intExtractLength);
      Ras.trace(this.getClass().getName(),"pullStringFromIndexes","extract length: ", integerTemp);                      
      Ras.trace(this.getClass().getName(),"pullStringFromIndexes","returning following string: ",
        stringInput.substring(intExtractStart, intExtractStart+intExtractLength));                      
    }

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"pullStringFromIndexes"); }

    // return the extracted string
    return ( stringInput.substring(intExtractStart, intExtractStart+intExtractLength));
  }

  // ****************************************************************************

  public boolean isDBCSCodePage(String codePage)
  { boolean booleanReturnCode = false;

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"isDBCSCodePage"); }

    booleanReturnCode = checkCodePages(DBCSCodePages,  codePage);

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"isDBCSCodePage"); }

    return booleanReturnCode;

  }

  // ****************************************************************************

  private boolean checkCodePages(int[] codePageList, String codePage)
  { // check a list of code page numbers with a String that represents a number
    boolean booleanReturnCode = false;;

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"checkCodePages"); }

    if ((codePageList == null) || (codePage == null))                                 
    { 
      if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"checkCodePages"); }
      return booleanReturnCode;
    }
    try
    { 
      booleanReturnCode = checkCodePages(codePageList, Integer.valueOf(codePage).intValue());
      if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"checkCodePages"); }
      return booleanReturnCode;
    }
    catch (NumberFormatException e)
    { 
      // If a number format exception is caught then our value can not match any of the predefined values
      // so return false.                                                               
      if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"checkCodePages"); }
      return booleanReturnCode;
    }
  }

  // ****************************************************************************

  private boolean checkCodePages(int[] codePageList, int codePage)
  { // check a list of code page numbers with a code page number 
    boolean booleanReturnCode = false;

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"checkCodePages"); }

    for (int i=0; i < codePageList.length; i++)
    { if (codePageList[i] == codePage)
      { booleanReturnCode = true;
        if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"checkCodePages"); }
        return booleanReturnCode;
      }
    }
    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"checkCodePages"); }
    return booleanReturnCode;
  }

  // ****************************************************************************

  static public final int[] DBCSCodePages =
  { 930,   // Japan Kana Ext
    939,   // Japan Eng Ext
    933,   // Korean
    937,   // Traditional Chinese
    935,   // Simpilified Chinese
    942,   // Japan ASCII
    949,   // Korea ASCII
    950,   // T-Chinese ASCII
    948,   // T-Chinese ASCII
    964,   // T-Chinese ASCII
    1381   // Simplified Chinese 
  }; 

  // DBCS range table for UNICODE
  private static final char[][] dbrange =
  {
    {'\u00B0', '\u00FF'},              // DB Latin 1 supplement        
    {'\u0100', '\u01FF'},              // DB Latin 1 Extended-A        
    {'\u02B0', '\u02E9'},              // DB Spacing Modifier          
    {'\u0370', '\u04FF'},              // DB Greek/Cyrillic            
    {'\u2000', '\u27BE'},              // DB Symbols                   
    {'\u3000', '\u33FE'},              // CJK Misc
    {'\u4E00', '\u9FFF'},              // CJK Ideographics
    {'\uAC00', '\uD7A3'},              // Hanguel                      
    {'\uE000', '\uF8FF'},              // User defined                 
    {'\uF900', '\uFAFF'},              // CJK Compatibility
    {'\uFE30', '\uFE4F'},              // CJK Compatibility
    {'\uFE50', '\uFE6F'},              // Small form Variants
    {'\uFF01', '\uFF5E'},              // full width ASCII
    {'\uFFE0', '\uFFE6'},              // full width punctuation and currency signs

    {'\u0000', '\u0000'}               // end of table
  };

  // ****************************************************************************

  public boolean IsDBCSChar(char charInput)                
  { // check if input char (UNICODE character value) is within DBCS range
    int i;
    // if not DBCS session, always return false
    boolean booleanDBCS = false;                                          

    // If single byte Korean Won, it should be treated as SBCS chracter
    if (charInput == '\u20a9')                                        
    { return booleanDBCS;                                                
    }

    // If single byte Euro sign, it should be treated as SBCS chracter
    if (charInput == '\u20ac')                                        
    { return booleanDBCS;                                                
    }

    // go thru the DBCS range table, and find if char is DBCS
    for (i=0; dbrange[i][0] != '\u0000'; i++)
    { // if character is within DBCS range, return true
      if ( (dbrange[i][0] <= charInput) && (dbrange[i][1] >= charInput) )
      { booleanDBCS = true;
        break;
      }
    }

    // these characters also take two columns for DBCS codepages
    if (  (!booleanDBCS)
        &&(  (charInput == 0xa1)  // inverted !
           ||(charInput == 0xa4)  // currency Sign    
           ||(charInput == 0xa7)  // section sign     
           ||(charInput == 0xa8)  // diaeresis        
           ||(charInput == 0xaa)  // a with underscore
         )
       )                  
    { booleanDBCS = true;                                               
    }

    return booleanDBCS;                   
  }                                   
                                        
  // ****************************************************************************
                                        
  public void macroStateEvent(MacroStateEvent oMacroStateEvent)
  { // a HOD macroStateEvent was fired for this macro 
    MacroScreen oMacroScreen;

    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"macroStateEvent"); }

    switch (oMacroStateEvent.getState())
    { case MacroStateEvent.STATE_STOPPED:
        // Macro is Stopped, which means it is ready to be played (which can also mean
        // that the macro has finished playing)
        if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","STATE_STOPPED fired"); }

        oMacroScreen = oMacroStateEvent.getMacroScreen();
        if (oMacroScreen != null)
        { hPubScreenState = oMacroScreen.getName();
        }

        synchronized(this)
        { switch (intMacroState)
          { case MACRO_STATE_INSTANTIATED:
              intMacroState = MACRO_STATE_READY_TO_PLAY;
              if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent",
                                              "perform notify at STATE_STOPPED(INSTANTIATED)"); }
              // We are waiting in method "DoTheWork" to start playing
              notify();
            break;

            case MACRO_STATE_PLAYING:
            case MACRO_STATE_PARSE_ERROR:
              intMacroState = MACRO_STATE_PLAY_FINISHED;
              if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","perform notify at STATE_STOPPED"); }
              // We are waiting in method "DoTheWork" to be finished playing 
              notify();
            break;
 
            default:
            break;
          }
        }
      break;

      case MacroStateEvent.STATE_PLAYING:
        if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","STATE_PLAYING fired"); }

        oMacroScreen = oMacroStateEvent.getMacroScreen();
        if (oMacroScreen != null)
        { hPubScreenState = oMacroScreen.getName();
        }

      break;

      case MacroStateEvent.STATE_RECORDING:
      case MacroStateEvent.STATE_PLAY_PAUSED:
      case MacroStateEvent.STATE_RECORD_PAUSED:
        // Since the macro is being run to completion, we don't expect to be in this state.
        if (HPubTracingOn)
        { Ras.trace( this.getClass().getName(),"macroStateEvent", "STATE_RECORDING/PLAY_PAUSED/RECORD_PAUSE fired");
        }
      break;
 
      case MacroStateEvent.STATE_EMPTY:
         if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","STATE_EMPTY fired"); }
         // Trace and Log Error
         HPubErrorsToLog oErrorsToLog2 = new HPubErrorsToLog();
         oErrorsToLog2.handleMessage(oHttpServletRequest, stringBeanName, this.getClass().getName(),
             "macroStateEvent", "HOD_Macro_Error_3", HPubTracingOn);

         stringHODMacroError = new String("HOD_Macro_Error_3");

         synchronized(this)
         { switch (intMacroState)
           { case MACRO_STATE_INSTANTIATED:
               intMacroState = MACRO_STATE_READY_TO_PLAY;
               if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent",
                                               "perform notify at STATE_EMPTY(INSTANTIATED)"); }
              // We are waiting in method "DoTheWork" to start playing
               notify();
             break;

             case MACRO_STATE_PLAYING:
             case MACRO_STATE_PARSE_ERROR:
               // we should never get here (can't be playing an empty macro)
               intMacroState = MACRO_STATE_PLAY_FINISHED;
               if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","perform notify at STATE_EMPTY"); }
               // We are waiting in method "DoTheWork" to be finished playing 
               notify();
             break;
           }
         }
      break;
 
      case MacroStateEvent.STATE_DISCONNECTED:
        if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","STATE_DISCONNECTED fired"); }

        stringHODMacroError = new String("HOD_Macro_Error_1");

        switch (intMacroState)
        { case MACRO_STATE_INSTANTIATED:
          case MACRO_STATE_PLAYING:
          case MACRO_STATE_PARSE_ERROR:
            synchronized(this)
            { intMacroState = MACRO_STATE_PLAY_FINISHED;
              if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","perform notify at STATE_DISCONNECTED"); }
              notify();
            }
          break;

          default:
          break;
        }
      break;
 
      case MacroStateEvent.STATE_PLAY_ERROR:
        ECLErr               oECLErr;
        ECLSession           oECLSession;
        ECLPS                oECLPS;
        char[]               caBufferForOneRow;
        int                  intNumberOfRows;
        int                  intNumberOfColumns;
        int                  intReadCount;
        StringBuffer         stringbufferScreenToLog = new StringBuffer();
        String               stringScreenToLog;
        String               stringMacroLineInError;
        int                  intECLErrMsgNumber;
        String               stringECLErrText;
        HPubErrorsToLog      oErrorsToLog = new HPubErrorsToLog();

        // Log and Trace the information we know about the status of the bean and macro
        // Add messages to the ErrorsToLog object and then log and trace them with
        // the ErrorsToLog.log() method

        ResourceBundle res = ResourceBundle.getBundle("com.ibm.HostPublisher.IntegrationObject.HPub_Resources",
                                                      Locale.getDefault());
        if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","STATE_PLAY_ERROR fired"); }


        // get the name of the last screen this macro was on
        oMacroScreen = oMacroStateEvent.getMacroScreen();
        if (oMacroScreen != null)
        { hPubScreenState = oMacroScreen.getName();
        }

        // log/trace the bean name
        if (res != null)
        { String stringTemp = res.getString("Bean_Name");
          oErrorsToLog.concatAndAddStrings(stringTemp, stringBeanName);
        }

        // log/trace the http session information
        oErrorsToLog.addHttpServletRequestInformation(oHttpServletRequest);

        // log/trace the name of the host machine
        if (sessionHost.getHost() != null)
        { String stringTemp = new String(sessionHost.getHost());
          oErrorsToLog.stringToLog(stringTemp);
        }

        if (sessionHost.getSessionType().equals(ECLSession.SESSION_TYPE_3270_STR))
        { // log/trace LU Name (only valid for 3270 sessions)
          String stringTemp = null;
          stringTemp = sessionHost.getLUName();
          if (stringTemp != null)
          {  if (stringTemp.length() > 0)
             { 
               oErrorsToLog.stringToLog(stringTemp);
             }
          }
        }

        // log/trace the macro name
        if (macroBean != null)
        { String stringTemp1 = new String(res.getString("Macro_Name"));
          oErrorsToLog.concatAndAddStrings(stringTemp1, stringMacroName);
        }

        // log/trace the error message stored in HOD.
        oECLErr = oMacroStateEvent.getECLErr();
        if (oECLErr != null)
        {
          oErrorsToLog.stringToLog(oECLErr.GetMsgText());
        }

        // log/trace the name of the last screen this macro was on
        if (hPubScreenState != null)
        { if (res != null)
          { String stringTemp = new String(res.getString("Last_Screen_Name"));
            oErrorsToLog.concatAndAddStrings(stringTemp, hPubScreenState);
          }
        }
        else
        { if (res != null)
          { String stringTemp1 = new String(res.getString("Last_Screen_Name"));
            String stringTemp2 = new String(res.getString("Null_Returned"));
            oErrorsToLog.concatAndAddStrings(stringTemp1, stringTemp2);
          }
        }

        // log/trace the contents of the current(last) screen that we are on.
        oECLSession = sessionHost.getECLSession();
        if (oECLSession != null)
        { oECLPS = oECLSession.GetPS();
          if (oECLPS != null)
          { intNumberOfRows    = oECLPS.GetSizeRows();
            intNumberOfColumns = oECLPS.GetSizeCols();
            caBufferForOneRow  = new char[intNumberOfColumns + 1];

            stringbufferScreenToLog.append(res.getString("Screen_Dump"));
            stringbufferScreenToLog.append("\n");
            // Append horizontal rule
            for (int intI = 1; intI <= intNumberOfColumns + 2; intI++)
            { stringbufferScreenToLog.append("-");
            }
            stringbufferScreenToLog.append("\n");

            // Append one row at a time, adding demarcating '|' characters at the
            // beginning and the end of each row.
            for (int intCurrentRow = 1; intCurrentRow <= intNumberOfRows; intCurrentRow++)
            { try
              { intReadCount = oECLPS.GetString(caBufferForOneRow, intNumberOfColumns + 1,
                                                intCurrentRow, 1, intNumberOfColumns);

                // Replace null character with demarcation character.
                caBufferForOneRow[intReadCount] = '|';
                stringbufferScreenToLog.append("|" + new String(caBufferForOneRow) + "\n");
              }
              catch (ECLErr oException)
              { // If we get an exception while trying to print the error
                // information, then log the fact we got an exception, but don't
                // worry about the details of the exception
                String stringTemp = res.getString("ECLPS_Error_1");
                oErrorsToLog.stringToLog(stringTemp);
              }
            }

            // Append horizontal rule
            for (int intI = 1; intI <= intNumberOfColumns + 2; intI++)
            { stringbufferScreenToLog.append("-");
            }
            stringbufferScreenToLog.append("\n");

            stringScreenToLog = new String(stringbufferScreenToLog);
            oErrorsToLog.stringToLog(stringScreenToLog);
          }
        }

        oErrorsToLog.log(Ras.TYPE_ERROR, stringBeanName, this.getClass().getName() );

        stringHODMacroError = new String("HOD_Macro_Error_1");

        switch (intMacroState)
        { case MACRO_STATE_INSTANTIATED:
          case MACRO_STATE_PLAYING:
          case MACRO_STATE_PARSE_ERROR:
            synchronized(this)
            { intMacroState = MACRO_STATE_PLAY_FINISHED;
              if (HPubTracingOn)
              { Ras.trace( this.getClass().getName(),"macroStateEvent","perform notify at STATE_PLAY_ERROR");
              }
              notify();
            }
          break;

          default:
          break;
        }

      break;

      default:
        if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"macroStateEvent","Unknown macro state fired"); }
      break;
    }

    if (HPubTracingOn) { Ras.traceExit( this.getClass().getName(),"macroStateEvent"); }
  }

} // end class
